with Exception_Manager;	                                      --  1 Put Exception_Manager package in scope
package Application_With_Exception is	                    --  2 
   type Application_Type is private;                          --  3 Private here is partial definition of type
   procedure Start       (Data : in out Application_Type);    --  4 Create and initialize the application
   procedure Restart   (Data : in out Application_Type);      --  5 If there is an exception, you may need to restart
   procedure Stop       (Data : in out Application_Type);     --  6 Stop the application; may be able to restart
   procedure Cleanup (Data : in out Application_Type);        --  7 When there is an error, call this procedure
   procedure Finalization (Data : in out Application_Type);   --  8 Not be confused with Ada.Finalization 
   Application_Exception : exception                          --  9 Your locally defined exception for this package
          renames Exception_Manager.Divide_By_Zero;           --  9.1
private		                                            -- 10  Nothing is public from here forward 
   type Application_Type is -- full definition of type	  -- 11 Full definition of the private type end Application_With_Exception; 
            digits 7;                                         -- 11.1
end Application_With_Exception;                               -- 12 End of the specification unit. Needs a body.