with Ada.Text_Io;	                                             --  1 			
use  Ada;	                                                   --  2
procedure Array_Definitions is	                           --  3
   package Bio is new Text_Io.Enumeration_Io(Enum => Boolean); --  5 IO package for Boolean type
   type Boolean_Set is array (1 .. 4) of Boolean;              --  6 Constrained boolean array
   pragma Pack(Boolean_Set);	                                 --  7 Forces array to four bits
   for Boolean_Set'Alignment use 2;	                           --  7.1 Align storage on 2 bytes
   type Float_Vector is array (Natural range <>) of Float;     --  8 Unconstrained array
   -- Note that the index is of type Natural and can be any range of values from 0 through Integer'Last
   B1 : Boolean_Set := (True, True, True, False);	         --  9
   B2 : Boolean_Set := (False, False, True, False);	         -- 10
   B3 : Boolean_Set := (True, True, False, True);	         -- 11  
   F1 : Float_Vector(0..9) ;	                                 -- 12
   F2 : Float_Vector(1..10);	                                 -- 13 
   procedure Display (Data : Boolean_Set; Comment : String) is -- 14 
   begin	                                                   -- 15 
      Text_Io.Put(Comment);	                                 -- 16 
      for I in B3'range loop	                                 -- 17 
         Bio.Put(Data(I));	                                 -- 18 
         Text_Io.Put(" ");	                                 -- 19 
      end loop;	                                             -- 20 
      Text_Io.New_Line;	                                       -- 21
   end Display;	                                             -- 22
begin	                                                         -- 23
   F1(2) := F2(4);	                                       -- 24 Simple component assignment
   F1(5..7) := F2(6..8);
   -- This is sometimes called "sliding"	                     -- 25 Assign slices of different sizes
   Display (B1, "B1 is ");	                                 -- 26
   Display (B2, "B2 is ");	                                 -- 27
   B3 := B1 and B2;	                                       -- 28 Logical and of B1 and B2
   Display(B3, "B1 and B2 = ");	                           -- 29 
   B3 := B1 or B2;	                                       -- 30 Logical or of B1 and B2
   Display(B3, "B1 or B2 = ");	                           -- 31
   B3 := B1 xor B2;	                                       -- 32 Logical xor of B1 and B2
   Display(B3, "B1 xor B2 = ");	                           -- 33
end Array_Definitions;	                                       -- 34  