-- ====================================================================================
-- Ada Distilled 
--
-- ====================================================================================
with Machinery, Rotating_Machinery;	                             --  1  
with Ada.Integer_Text_Io;	                                   --  2  Enables the input of the array index
procedure Dynamic_Binding_Example_3 is                           --  3  Specification for the example procedure
   Index : Natural range 0..2 := 0;                              --  4  Use this to index into the array
   function Get (The_Index : Natural) return                     --  5
                      Machinery.Machine'Class  is                --  6  Procedure with classwide parameter
      Data : array (1..2) of Machinery.Reference := 	           --  6
         (1 => new Machinery.Machine, 	                       --  7
          2 => new Rotating_Machinery.Rotational);	           --  8 
   begin			                                         --  9
      return Data(The_Index).all;                                -- 10   return the data access by Data(Index)
   end Get;		                                               -- 11  
begin				                                         -- 12 
   Ada.Integer_Text_Io.Get(Index);                               -- 13 Get the index for the next statement 
   declare			                                         -- 14 Start a local declare block 
      The_Machine : Machinery.Machine'Class := Get(Index);       -- 15 Declare and constrain classwide variable
   begin			                                         -- 16 
      Machinery.Turn_On(The_Machine);                            -- 17 Call classwide procedure dynamically constrained data
   end;			                                         -- 18 
end Dynamic_Binding_Example_3;	                             -- 19 