with Ada.Exceptions; use Ada;	                                  --  1 Chapter 11.4.1 ALRM
package  Exception_Manager  is                                  --  2 A typical exception/error management package
   Overflow           : exception;                             --  3 Own named exception;  User-defined exception
   Underflow          : exception;                              --  4 Ada exception is not a first class object
   Divide_By_Zero : exception;                                  --  5 This could be handy for some applications
   type Exception_Store is tagged limited private;              --  6 A place to store exception occurrences
   type Reference is access all Exception_Store'Class;          --  7 In case you need to reference this in another way
   procedure Save(Error : Exceptions.Exception_Occurrence);     --  8 Saves an exception to Exception_Store
   procedure Log(Error : Exceptions.Exception_Occurrence);      --  9 Logs an exception
   procedure Display(Error : Exceptions.Exception_Occurrence);  -- 10 Displays and exception
private		                                              -- 11 Useful to have more operations before this
   type Exception_Set is array (1 .. 100)                       -- 12 Array of access values to Exception_Occurrence		
        of  Exceptions.Exception_Occurrence_Access;             -- 13 Exception_Occurrence_Access is an access type
   type Exception_Store is tagged limited                       -- 14 A record containing an array of exceptions
        record                                                  -- 15 
           Current_Exception : Natural := 0;                    -- 16 And index over the Exception_Set 
           The_Exception_Set : Exception_Set;                   -- 17 Instance of type from Lines 12-13 
        end record;                                             -- 18 
end Exception_Manager;	                                        -- 19 Package scope terminator