-- ==========================================================================================
-- Ada Distilled              by Richard Riehle, AdaWorks Software Engineering
--                                               For your Ada training and consulting needs
-- Main.adb
--
-- See 6.1.3 in Ada Distilled for discussion of this program.
--
-- Demonstrates how to create a main program for an application package
--  
-- Line numbers correspond to those in Ada Distilled.
-- 
-- =========================================================================================
-- 
with Application;                       	                  --  1 Put package Application in scope;  10.1.2,
procedure  Main  is	                                    --  2 Parameterless declaration; 	6.3
   The_Application : Application.Application_Type;          --  3 Some kind of  type for the application
begin	-- Main	                                          --  4 Begins Main subprogram; 	6.3
   Restart_Iterator:	                                    --  5 We want a non-stop system so we
      loop			                                    --  6 create a restart iterator  as a loop.
      Application_Control:	                              --  7 Label the Application control block
         begin -- Application_Control	                  --  8 No harm in commenting every begin
         Application.Start(Data => The_Application);        --  9 Start the application code
         Application.Stop(Data => The_Application);         -- 10 Stop the application code
         exit Restart_Iterator;                             -- 11 If all goes well, exit the loop here.
      exception	                                          -- 12 If there is an exception anywhere, do this.
         when  others =>	                              -- 13 Others captures any kind of exception 
            Application.Cleanup(Data => The_Application);   -- 14 Start the cleanup before Restarting
            Application.Restart  (Data => The_Application); -- 15 Now restart the application
      end Application_Control;                              -- 16 Block label required because it is labeled
   end loop Restart_Iterator;                               -- 17 Loop label required because it is labeled
   Application.Finalization (Data => The_Application);      -- 18 The finalization routines for application
end Main;			                                    -- 19 Scope terminator with unit name  6.3