package Mapping_Example is -- Begin the enclosing package specification	                          --  1
   generic	                                                                                      --  2
      type Mapping_Type is private;                                                               --  3
      type Key is limited private;                                                                --  4
      type Value is limited private;                                                              --  5
      with procedure Add    (M : in out Mapping_Type; K : in Key; V : in Value);	              --  6
      with procedure Remove (M : in out Mapping_Type; K : in Key; V : in Value);	              --  7
      with procedure Apply  (M : in out Mapping_Type; K : in Key; V : in Value);	              --  8
   package Mapping is end Mapping;	                                                              --  9
   -- Now declare the specification for the generic procedure in the same package
   generic 	                                                                                      -- 10
      with package Mapping_Operations is new Mapping (<>);	                                      -- 11
      use Mapping_Operations;                                                                     -- 12
      -- This is a generic formal package parameter instead of a generic formal subprogram	  -- 13
   procedure Do_Something(M : in out Mapping_Operations.Mapping_Type; K : in Key; V : in Value);  -- 14
end Mapping_Example; -- End of the enclosing package specification	                          -- 15