-- ==========================================================================================
-- Ada Distilled              by Richard Riehle, AdaWorks Software Engineering
--                                               For your Ada training and consulting needs
-- Statistics.ads
--
-- See      in Ada Distilled for discussion of this program.
--
-- 
--
-- Line numbers correspond to those in Ada Distilled.
-- 
-- =========================================================================================
-- 
package Statistics is	                                --  1 Specification declaration 
   type Data is array (Positive range <>) of Float;     --  2 An  unconstrained array.	
   function Mean     (The_Data : Data) return Float;    --  3 Computes the statistical Mean
   function Mode     (The_Data : Data) return Float;    --  4 Computes the statistical Mode
   function Max      (The_Data : Data) return Float;    --  5 Computes Maximum Value of  arrray
   function Min      (The_Data : Data) return Float;    --  6 Computes Minimum Value of array
   function Variance (The_Data : Data) return Float;    --  7 Computes Statistical Variance
   function Stddev   (The_Data : Data) return Float;    --  8 Computes Standard Deviation
end Statistics;		                                --  9  Package specification requires end 